#! /usr/local/bin/perl5
#############################################################################
#  
#   File:          PostIt.pl
#
#   Author:        Jungmin Kim
#
#   Created:       03/05/95
#   Modified:      
#   Version: 
#
#   Description:   &MakeNewFile generates new message file with passed 
#                  arguments
#               
#############################################################################


#############################################################################
#
#   MakeNewFile
#
#   INPUT:  path name, file name, method(replry or post), title,
#           message, user information
#
#   OUTPUT: name of new message (file name)
#
#   FUNCTION: Generate a new message file and save the header of it to
#             index file. 
#
#############################################################################

sub MakeNewFile{
    local($dir, $file, $method, $user, $title, $message) = @_;
    local($uname, $upass, $cnt, @in, $i, $init);

    $title =~ s/&gt;/\>/g;
    $title =~ s/&lt;/\</g;
    $title =~ s/&quot;/\"/g;    
    $title =~ s/&amp;/&/g;
    $message =~ s/&gt;/\>/g;
    $message =~ s/&lt;/\</g;
    $message =~ s/&quot;/\"/g;    
    $message =~ s/&amp;/&/g;
    $user =~ s/\+/ /g;

    $title =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>/g;
    $title =~ s/(\r\n|\n|\r|\s+)/ /g;
    $message =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>\n/g;

    ($uname, $upass) = split(/\:/, $user);

    #### dummy header
    push(@in, ("0", &GetDate(0), $uname, "$title\n"));
    $cnt =0;

    $filename = "$dir/$index";


    ### make a backup file 
    system("cp $filename $filename.bak");


    #### open index file to read headers of a conference
    $filename = "$dir/$index";
    # ******************************************* hardwired variable
    open(INFILE, "< $filename") || print "Cannot open $filename\: $!";

    while(<INFILE>) {
	# ********************************************* modified
	push(@in, split(/\005/, $_));
	# *****************************************************
	$cnt += 4;
    }
    close(INFILE);

    #### generate new file name
    $in[0] = "0";
    if ($method eq "newpost") {
	for($i=4; $i < $#in; $i += 4) {
	  $in[$i] =~ /^([^\.]+)/;
	  $in[0] = $1 + 1 if $in[0] <= $1;
        }
    }
    elsif($method eq "response") {
        $next = "1";
	$init = $1 if $file =~ /^(.+)\.([^\.]*)/;
	$init = $file if $file =~ /^[^\.]+$/;
	for($i = 0; $i <= $cnt; $i += 4) {
	    if ($in[$i] =~ /^$init\.([^\.]*)/) {
		$next = $1 + 1 if $next <= $1;
	    }
        }
	$in[0] = $init."\.".$next;
    }
    else {
        $next = "1";
	for($i = 0; $i <= $cnt; $i += 4) {
	    if ($in[$i] =~ /^$file\.([^\.]*)/) {
		$next = $1 + 1 if $next <= $1;
	    }
        }
	$in[0] = $file."\.".$next;
    }

    ### write the modified headers to index file
    $i = 0;
    open(OUTFILE, "> $filename") || 
	print "Content-type\: text/html\n\n\n Cannot open $filename\: $!";
    while($i<=$cnt) {
	# ****************************************************** modified
	print OUTFILE "$in[$i++]\005$in[$i++]\005$in[$i++]\005$in[$i++]";
        # ***************************************************************
    }
    close(OUTFILE);

    #### write the message file

    $filename = ">$dir/$in[0].html";
    open(OUTFILE,$filename) ||
	print "Content-type\: text/html\n\n\n Cannot open $filename\: $!";
    print  OUTFILE $message;
    close(OUTFILE);

    $in[0];
}
1;
