#! /usr/local/bin/perl5
#############################################################################
#  
#   File:        PrintHeader2.pl
#
#   Author:      Jungmin Kim
#
#   Created:     04/02/95
#   Modified: 
#   Version: 
#
#   Input:       path name, file name, user information, 
#                address of array
#   Output:      HTML text
#          
#
#   Description: Print out headers of messages in the directory 'path name'
#                with numerical order
#
#############################################################################

sub PrintHeader2{

    # local($dir, $no, $user) = @_;
    local($dir, $no, $user) = @_;
    local($number, $date, $name, $title, $tno, $temp, %files);

    open(INFILE,"< $dir/$index");
    while(<INFILE>) {
        # separator for each field is eot(\005) ****************** modified
	($number, $date, $name, $title) = split(/\005/, $_);

	# replace <BR> and <P> with a space
	$temp = $title;
	$title =~ s/\<P\>/ /ig;
	$title =~ s/\<BR\>/ /ig;
	$files{$number} = "$date\005$name\005$title";

    }
    close(INFILE);

    print "<pre>";
    foreach $key (sort dotorder keys %files) {
        $key =~ /^([0-9]+).*/;
        $tno = $1;                 # prefix of file name (root message)
	($date, $name, $title) = split(/\005/, $files{$key});
	#### formmated printing
        printf("%-10s %-5s %-17s ", $key, $date, $name);

        print "<A HREF=\"$action/read\:${dir}\:${tno}\:${user}#$key\">"; 
        print "${title}";
        print "</A>";
    }
    print "</pre>";
}
1;


