#! /usr/local/bin/perl5
#############################################################################
#  
#   File: SelectBoard.pl 
#
#   Author:        Jungmin Kim
#
#   Created:       March 5  1995
#   Modified:      March 23 1995 by Paul Coddington 
#   Version: 
#
#   Input:         username
#   Output:        HTML text
#          
#
#   Description:   Print out HTML page of index of conferences 
#               
#   Usage:         "http://.../Action.pl/select:(NULL):(NULL):user"
#                  'user' should be "username:email_address".
#
#############################################################################

sub SelectBoard {
    local($user) = @_;		      # user information
    local($key);

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> WeBBoard Conference Index </TITLE>\n";

    # Open file containing the title of this version of WeBBoard
    $titlefile = "CHECK/title";
    if ( open(INFILE, "< $titlefile") ) {
      while (<INFILE>) {
        $title = $_;
      }
      print "<H2> WeBBoard Conference Index for </H2>\n";
      print "<H1> $title </H1>\n";
    }
    else {
      print "<H2> WeBBoard Conference Index </H2>\n";
    }

    print "<BR>\n";
    print "<H3><i> Select a conference from the index below\:</i></H3>\n";
    print "<HR>\n";
    print "<H3>\n";
    print "<UL>\n";

    # *************************************************************** modified

    foreach $key (sort keys %conference) {
	if ($key eq "") { next;}
	print "<LI>\n";
	print "<A HREF=\"${action}/read\:$key\:\:$user\">";
	print " $conference{$key} </A><P>\n";
    }
    # ************************************************************************

    print "</UL>\n";
    print "</H3>\n";
    print "<HR>\n";

    # *************************************************************** modified

    #### if user name is administrator, print out options to change configuration
    if($user =~/^administrator\:/) {

    print "Choose one of the following to change configuration\n";
    print "<DL><DD>\n";
    print "<B>\n";
    print "<FORM METHOD=\"POST\" ACTION=\"$change/\:${user}\">\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"adduser\"";
    print " CHECKED>\n";
    print " Add a new user name<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"deluser\">\n";
    print " Delete a user name<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"addconf\">\n";
    print " Add a new conference<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"delconf\">\n";
    print " Delete a conference<BR>\n";
    print "</B></DL>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print " Press this button to submit. <P>\n";    
    print "<HR>\n";

    }
    # ************************************************************************

    print "<ADDRESS>\n";
    print "<A HREF=\"$webteam\">\n";
    print "The WeBBoard development team</A>\n";
    print "</ADDRESS>\n";

}
1;

