#! /usr/local/bin/perl5
#############################################################################
#  
#   File:          PostMessage.pl
#
#   Author:        Jungmin Kim
#
#   Created:       03/05/95 
#   Modified:      
#   Version: 
#
#   Input:         path anem, file name, 
#                  title, message, (current message for feed back)
#                  hidden date, hidden name, hidden title, hidden message
#                  ( message to be responded ),
#                  user information
#   Output:        HTML text with fill-out forms
#          
#
#   Description:   Create fill-out forms to edit message.
#                  passed message (to be responded), and made message are
#                  passed to main function.
#                  passed message: path/filename
#                  new message:    path/(new file)
#               
#   Usage:         "http://.../Action.pl/post:path:file:user"
#                  user should be "username:email_address".
#
#
#############################################################################

sub PostMessage{
    local($path, $file, $title, $message, 
	  $hdate, $hname,  $htitle, $hmessage, $method, $user) = @_;

    # ****************************************************** modified
    local($pname, $pemail, $html_title, $html_message, 
	  $response, $comment, $newpost, $pathname );

    if ($method eq "" || $method eq "response") {
	$response = "CHECKED";
	$comment = $newpost = "";
    }
    elsif ($method eq "comment") {
	$comment = "CHECKED";
	$response = $newpost = "";
    }
    else {
	$newpost = "CHECKED";
	$response = $comment = "";
    }

    $html_title = $htitle;
    $html_message = $hmessage;
    # ***************************************************************

    #### replace HTML reserved characters
    $htitle =~ s/&/&amp;/g;
    $htitle =~ s/>/&gt;/g;
    $htitle =~ s/</&lt;/g;
    $htitle =~ s/\"/&quot;/g;
    $hmessage =~ s/&/&amp;/g;
    $hmessage =~ s/>/&gt;/g;
    $hmessage =~ s/</&lt;/g;
    $hmessage =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $title =~ s/>/&gt;/g;
    $title =~ s/</&lt;/g;
    $title =~ s/\"/&quot;/g;
    $message =~ s/&/&amp;/g;
    $message =~ s/>/&gt;/g;
    $message =~ s/</&lt;/g;
    $message =~ s/\"/&quot;/g;
    $_ = $user;
    s/\+/ /g;
    #### decore user information
    ($pname, $pemail) = split(/:/, $_);

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> POST MESSAGE </TITLE>\n";
    print "<H1> Post a Message </H1>\n";
    print "<HR>\n";

    # ******************************************************** modified
    $pathname = $conference{$path};
    print "<B>CONFERENCE\:</B> ${pathname} <BR>";
    print "<B>RESPONDING TO MESSAGE\:</B> $file. $html_title";
    # *****************************************************************

    print "<i>(this message is appended at the bottom of the page)</i>\n";
    print "<P>\n";
    print "<B><A HREF=\"$action/read\:$path\:$file\:$user#$file\">\n";
    print "CANCEL this post and return to the conference</A></B>\n";
    print "<HR>\n";

    print "<P>\n";
    print "<FORM METHOD=\"POST\" ACTION=\"$action/preview\:$path\:$file\:$user\">\n";
    print "<DL><DT><B>Choose one of the following</B>\:\n";
    print "<DD>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"response\" $response>\n";
    print "<i> Add a response concerning this topic </i><BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"comment\" $comment>\n";
    print "<i> Add a comment specific to this particular message </i><BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"newpost\" $newpost>\n";
    print "<i> Post a new independent message</i><BR>\n";
    print "</DL>\n";

    #### hidden fields to be passed

    print "<INPUT TYPE=\"hidden\" NAME=\"hdate\" VALUE=\"${hdate}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname\" VALUE=\"${hname}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle\" VALUE=\"${htitle}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage\" VALUE=\"${hmessage}\">\n";


    #### generate fill-out forms
    
    print "<P>\n";
    print "<BR>\n";
    print "<B>Type in a subject title for your message\: </B><BR>\n";
    print "<TEXTAREA NAME=\"title\" ROWS=2 COLS=60>${title}</TEXTAREA><P>\n";
    print "<B>Type in your message\: </B><BR> ";
    print "<TEXTAREA NAME=\"message\" ROWS=20 COLS=60>${message}</TEXTAREA> <P>\n";

    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print "<B>Press this button to preview and submit your message.</B><P>\n";

    print "</FORM>";

    #### Include the message you're replying to

    print "<P><HR>\n";
    print "<H3>You are responding to the following message\:</H3>\n";
    print "<P>\n";
    print "<B>Date\: </B>$hdate<br>\n";
    print "<B>Author\: </B>$hname<P>\n";
    print "<B>Title\: </B> $html_title\n";

    # ******************************************************** modified
    print "<DL>\n";
    print "<DT><B>Message\: </B><P>\n";
    print "<DD> $html_message\n";
    print "</DL>\n";
    # *****************************************************************
}
1;
