#! /usr/local/bin/perl5
#############################################################################
#  
#   File:          PreviewMessage.pl
#
#   Author:        Jungmin Kim
#
#   Created:       03/05/95
#   Modified:      
#   Version: 
#
#   Input:         path name, file name,
#                  title, message (current message)
#                  hidden date, hidden name, hidden title, hidden message
#                  (message to be responded)
#                  user information
#   Output:        HTML text
#          
#
#   Description:   Print out the message entered to preview the message 
#                  before post it. both of current message and the 
#                  message to be responded are passed to main function
#               
#   Usage:         "http://.../Action.pl/preview:path:file:user"
#                  user should be "username:email_address".
#
#
#############################################################################

sub PreviewMessage{
    local($path, $file, $title, $message, 
	  $hdate, $hname,  $htitle, $hmessage, $method, $user) = @_;

    local ($temp);

    $temp = $htitle;		# original title of message to be responded
    $temp =~ s/\<P\>/ /ig;
    $temp =~ s/\<BR\>/ /ig;

    #### save message and titel to modify them
    $html_message = $message;
    $html_title = $title;

    #### replace HTML reserved characters
    $htitle =~ s/&/&amp;/g;
    $htitle =~ s/>/&gt;/g;
    $htitle =~ s/</&lt;/g;
    $htitle =~ s/\"/&quot;/g;
    $hmessage =~ s/&/&amp;/g;
    $hmessage =~ s/>/&gt;/g;
    $hmessage =~ s/</&lt;/g;
    $hmessage =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $title =~ s/>/&gt;/g;
    $title =~ s/</&lt;/g;
    $title =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $message =~ s/&/&amp;/g;
    $message =~ s/>/&gt;/g;
    $message =~ s/</&lt;/g;
    $message =~ s/\"/&quot;/g;
    $message =~ s/&/&amp;/g;
    # *******************************************************************

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> PREVIEW MESSAGE </TITLE>\n";
    print "<H1> Preview the Message </H1>\n";

    print "<HR>\n";
    # ********************************************************* modified
    $pathname = $conference{$path};
    print "<B>CONFERENCE\: </B>$pathname <BR>\n";
    # ********************************************************* modified

    if($method eq "response") {
        print "<B>RESPONDING TO MESSAGE\:</B> $file. $temp";
    }
    elsif($method eq "comment") {
        print "<B>RESPONDING TO MESSAGE\:</B> $file. $temp";
    }
    else {
	print "<B>POSTING A NEW INDEPENDENT MESSAGE</B>\n";
    }
    print "<BR><HR>\n";

    print "<FORM METHOD=\"POST\" ACTION=\"$action/postit\:$path\:$file\:$user\">\n";
    print "<P>\n";
    print "<DL><DT><B>Choose one of the following</B>\:\n";
    print "<DD>\n";
    print "<I>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"edit\" VALUE=\"no\" CHECKED>\n";
    print " Post the message<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"edit\" VALUE=\"yes\">\n";
    print " Edit the message <BR>\n";
    print "</I></DL>\n";

    #### hidden fields
    print "<INPUT TYPE=\"hidden\" NAME=\"hdate\" VALUE=\"${hdate}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname\" VALUE=\"${hname}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle\" VALUE=\"${htitle}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage\" VALUE=\"${hmessage}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"title\" VALUE=\"${title}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"message\" VALUE=\"${message}\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"method\" VALUE=\"${method}\">\n";

    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print "<B>\n";
    print " Press this button to post or edit your message, \n";
    print " which is appended below.\n";
    print "</B>\n";
    print "</FORM>\n";

    print "<HR><P>\n";

    #### replace all double CR and LF characters with <P>
    $html_title =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>\n/g;
    $html_message =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>\n/g;

    # ***************************************************** modified
    print "<B>Subject\: </B> $html_title \n";
    print "<P><B>Message\: </B><P>\n";
    print "$html_message <P>\n";

    $user =~ s/\+/ /g;
    ($username, $userid) = split(/\:/, $user);
    print "<I>\n";
    print $username, ", ", $userid,"\n";
    print "</I>\n";
    # **************************************************************

    print "<P><HR><p>\n";

}
1;

